package com.your_domain.your_product.employee.dao;

import java.util.ArrayList;

import com.jdbaccess.da.Transaction;
import com.jdbaccess.dao.DataAccessObjectImpl;
import com.jdbaccess.exception.ApplicationException;
import com.jdbaccess.sql.ComparisonCondition;
import com.jdbaccess.sql.LogicalCondition;
import com.jdbaccess.transfer.TransferObject;
import com.your_domain.your_product.employee.transfer.EmpAddr;

/**
 * Persistence layer: dao class of entity emp_addr 
 */
public class EmpAddrDaoImpl extends DataAccessObjectImpl implements EmpAddrDao {
  private static String ENTITY = EmpAddr.getEntityName();
  private static String CREATE_TABLE_STRING = 
    "create table " + ENTITY + " (empid int, addrid int, orderid int) engine = innodb";
  
  public EmpAddrDaoImpl() {
    super();
  }

  public EmpAddrDaoImpl(Transaction t) {
    super(t);
  }

  public void dropTable() throws ApplicationException {
    dropTable(ENTITY);  
  }
  
  public void createTable() throws ApplicationException {
    createTable(CREATE_TABLE_STRING);  
  }
  
  public EmpAddr insert(EmpAddr to) throws ApplicationException {
    ArrayList transferObjects = new ArrayList();
    transferObjects.add(to);
    ArrayList retTransferObjects = (ArrayList)insert(transferObjects);
    return (EmpAddr) retTransferObjects.get(0);
  }
  
  public ArrayList insert(ArrayList transferObjects) throws ApplicationException {
    for (int i=0; i<transferObjects.size(); i++) {
      TransferObject to = (TransferObject) transferObjects.get(i);
      to.setEntity(ENTITY);
    }
    return super.insert(transferObjects);
  }

  public void deleteByEmpId(Long empId) throws ApplicationException {
    EmpAddr empAddr = new EmpAddr();
    empAddr.setEmpId(empId);
    ComparisonCondition empIdComparison = new ComparisonCondition("empId", ComparisonCondition.EQUALS, null);
    LogicalCondition empIdCondition = new LogicalCondition(empIdComparison, LogicalCondition.EMPTY, null);
    empAddr.setWhereCondition(empIdCondition);
    super.delete(empAddr);
  }
  
  public void delete(ArrayList transferObjects) throws ApplicationException {
    for (int i=0; i<transferObjects.size(); i++) {
      EmpAddr empAddr = (EmpAddr) transferObjects.get(i);
      ComparisonCondition empIdComparison = new ComparisonCondition("empId", ComparisonCondition.EQUALS, null);
      ComparisonCondition addrIdComparison = new ComparisonCondition("addrId", ComparisonCondition.EQUALS, null);
      LogicalCondition empIdCondition = new LogicalCondition(empIdComparison, LogicalCondition.AND, addrIdComparison);
      empAddr.setWhereCondition(empIdCondition);
      super.delete(empAddr);
    }
  }

  public Long deleteAll() throws ApplicationException {
    return super.deleteAll(ENTITY);
  }
}
