package com.your_domain.your_product.employee.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;

import com.jdbaccess.client.ClientApplication;
import com.jdbaccess.db.JDBaccess;

/**
 * GUI-layer: about dialog 
 */
public class AboutDialog extends JDialog {
  static final long serialVersionUID = AboutDialog.class.hashCode();
  private JFrame owner;
  private JLabel jdbAccessImageLabel;
  private JLabel productLabel = new JLabel();;
  private JLabel licenseLabel = new JLabel("Demo License");
  private JLabel copyrightLabel = new JLabel("Copyright (C) 2005-2006");
  private JLabel urlLabel = new JLabel("www.jdbaccess.com");
  private JLabel emailLabel = new JLabel("support@jdbaccess.com");
  private JButton okButton = new JButton("OK");
    
  public AboutDialog(EmployeesFrame owner) {
    super(owner, "JDBaccess-Example: About", true);
    this.owner = owner;
    initGui();
    initListeners();
    setVisible(true);
  }

  private void initGui() {
    JPanel panelWest = createWestPanel();
    JPanel panelEast = createEastPanel();
    JPanel panelSouth = createSouthPanel();
    getContentPane().setBackground(Color.WHITE);
    getContentPane().add(panelWest, BorderLayout.WEST);
    getContentPane().add(panelEast, BorderLayout.EAST);
    getContentPane().add(panelSouth, BorderLayout.SOUTH);
    setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    setSize(650, 250);
    setLocation(owner.getLocation().x + 50, owner.getLocation().y + 150);
  }

  private JPanel createWestPanel() {
    SpringLayout springLayout = new SpringLayout();
    JPanel panel_north = new JPanel(springLayout);
    panel_north.setBackground(Color.WHITE);
    String version = ClientApplication.getVersion();
    productLabel.setText("JDBaccess Version " + version);
    String licenseType = "Demo";
    String dbType = "MySql";
    if (ClientApplication.isSngleLicense())
      licenseType = "Single Developer";
    else if (ClientApplication.isSteLicense())
      licenseType = "Site";
    if (JDBaccess.isOfTypeOracle())
      dbType = "Oracle";
    String licenseText = licenseType + " License for " + dbType;
    licenseLabel.setText(licenseText);
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(new JLabel(""));
    panel_north.add(productLabel);
    panel_north.add(licenseLabel);
    panel_north.add(copyrightLabel);
    panel_north.add(urlLabel);
    panel_north.add(emailLabel);
    SpringUtilities.makeCompactGrid(panel_north, 12, 1, 15, 15, 6, 6); //rows, cols, initX, initY, xPad, yPad
    return panel_north;
  }

  private JPanel createEastPanel() {
    Image logo = JDBaccess.getLogoImage();
    jdbAccessImageLabel = new JLabel(new ImageIcon(logo));
    FlowLayout flowLayout = new FlowLayout(FlowLayout.CENTER);
    JPanel panel = new JPanel(flowLayout);
    panel.setBackground(Color.WHITE);
    panel.add(jdbAccessImageLabel);
    return panel;
  }

  private JPanel createSouthPanel() {
    FlowLayout flowLayout = new FlowLayout(FlowLayout.RIGHT);
    JPanel panel_south = new JPanel(flowLayout);
    panel_south.setBackground(Color.WHITE);
    panel_south.add(okButton);
    return panel_south;
  }

  private void initListeners() {
    okButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        close();
      }
    });
  }

  private void close() {
    dispose();
  }

}
